Redmine - Defect #17809

wrong syntax highlighting "---" header and "--" footer of git diff
2014-09-06 12:37 - Tobias Fischer

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: ul Estimated time: 0.00 hour
Target version:

Resolution: Affected version: 25.2
Description

Rendering of patches adds an additional "deletion" line for the following (standard) diff syntax:

app/views/flayouts /base.html.erb

<%= yield :header tags =%>

</head>

<body class="<%=h body_css_classes %>">

<%= call hook :view_layouts_base body_ top %>
<div id="wrapper">

<div id="wrapper2":>

<div id="wrapper3">

Whereas the "deletion” of line 22 in the screenshot isn't part of the changeset at all:

From 901992fe9%db52e1df90a6a963a686cd2cf20e706 Mon Sep 17 00:00:00 2001
From: Tobias Fischer

Date: Sat, 6 Sep 2014 12:22:02 +0200

Subject: [PATCH] Additional view hook "body_top"

In the same way as "view_layouts_base_body_bottom" exists...
app/views/layouts/base.html.erb | 1 +
1 file changed, 1 insertion (+)

diff --git a/app/views/layouts/base.html.erb b/app/views/layouts/base.html.erb
index 99adl3f..45efbbd 100644

-—— a/app/views/layouts/base.html.erb

+++ b/app/views/layouts/base.html.erb

@@ -16,6 +16,7 Q@

<%= yield :header_tags -%>

</head>

<body class="<%=h body_css_classes %>">

+<%= call_hook :view_layouts_base_body_top %>
<div id="wrapper">

<div id="wrapper2">

<div id="wrapper3">

1.8.5.2 (Apple Git-48)
And also this diff gets wrong syntax highlighting for the meta-lines "---" and "-- "

So | would expect the line 22 not to be rendered at all and an the syntax highlighting, there should be no highlighting for "---" and "-- "

History

#1 - 2014-09-06 13:20 - Toshi MARUYAMA

- Subject changed from rendering of patch files (attachments) has a bug in reading the patch/diff format to rendering extra "--" footer of git patch

#2 - 2014-09-06 13:24 - Toshi MARUYAMA

Tobias Fischer wrote:
the following (standard) diff syntax:

It is not standard diff format.

It is git additional footer.

Mercurial patch does not have such footer.
source:tags/2.5.2/test/fixtures/diffs/issue-12641-ja.diff

#3 - 2014-09-06 13:29 - Toshi MARUYAMA

- Subject changed from rendering extra "--" footer of git patch to rendering extra "---" header and "--" footer of git patch

#4 - 2014-09-06 14:48 - Tobias Fischer
Toshi MARUYAMA wrote:

Tobias Fischer wrote:

the following (standard) diff syntax:

It is not standard diff format.
It is git additional footer.
Mercurial patch does not have such footer.

Oh, okay, sorry then.
But anyways, the "deletion" line shouldn't be rendered for git diffs then ;-)

#5 - 2020-04-04 10:59 - Go MAEDA

It can be fixed with the following code:

diff --git a/lib/redmine/unified_diff.rb b/lib/redmine/unified_diff.rb
index 67292cf0f..5c258b564 100644
-—— a/lib/redmine/unified_diff.rb
+++ b/lib/redmine/unified_diff.rb
@@ -78,7 +78,7 QR module Redmine
@parsing = true

end
else
- if $r{"["\+\-\s@\\]}.match? (line)
+ if /2 (["\+\=-\s@\\]|-- $)/.match? (line)
@parsing = false

return false
elsif line =~ /7@E (\+I\-) (\d+) (,\d+) 2 (\+I\-) (\d+) (,\d+)? ee/

#6 - 2020-04-26 16:47 - Toshi MARUYAMA
- Category changed from Attachments to Ul

#7 - 2020-04-26 17:03 - Toshi MARUYAMA
Go MAEDA wrote:

It can be fixed with the following code:

No.

| have created new #33357.

#8 - 2020-04-26 17:14 - Toshi MARUYAMA
- File 3.4.png added

- File 4.1.png added

- Subject changed from rendering extra "---" header and "--" footer of git patch to wrong syntax highlighting "---" header and "--" footer of git diff

- Status changed from New to Closed

3.4
https://www.redmine.org/projects/redmine/repository/svn/entry/tags/2.5.2/test/fixtures/diffs/issue-12641-ja.diff
https://www.redmine.org/issues/33357

From 9b1992fe9db52eldfI0atad63a686cd2cf20e706 Mon Sep 17 00:00:00 2001

From: Tobias Fischer
Date: Sat, 6 Sep 2014 12:22:02 +0D200
Subject: [PATCH] Additional view hook "body_top"

In the same way as "wview_layouts_base_body_bottom" exists...
app/views/layouts/base.html.erb | 1 +
1 file changed, 1 insertion(+)

diff --git a/app/views/layouts/base.html.erb b/app/views/layouts/base.html.erb

index 99ad13r..45efbbd 100644

1a

<k= yield :header_tags -%=

</head>

<body class="<%=h body_css_classes %="=

+<k= call hook :view layouts_base body top %=
<div id="wrapper"=

<div id="wrapper2"=

<div id="wrapper3">

1.8.5.2 (Apple Git-48)

4.1

From 9b19927e9db52eldf90a6a963a686cd2cT20e706 Mon Sep 17 00:00:00 2801

From: Tobias Fischer
Date: 5at, 6 Sep 2014 12:22:02 +0200Q
Subject: [PATCH] Additional view hook "body_ top"

In the same way as "view_ layouts_base body bottom" exists...

app/views/layouts/base. html.erb | 1 +
1 file changed, 1 insertion(+)

diff --git a‘app/views/layouts/base.html.erb b/app/views/layouts/base.html.erb

index 99adi3f..45ef5bd 100644
--- afapp/views/layouts/base.html.erb
+++ b/app/views/layouts/base.html.erb
My -16,6 +16,7 @@
<¥%= yield :header_tags -%=>
</head>
<body class="<¥=h body_css_classes %k>">
+<¥%= call hook :view_layouts_base_body top %=
<div id="wrapper"=>
=div id="wrapper2"=
<div id="wrapper3">

1.8.5.2 (Apple Git-48)

#9 - 2020-04-27 03:43 - Toshi MARUYAMA
Toshi MARUYAMA wrote:

Go MAEDA wrote:

It can be fixed with the following code:

No.

| have created new #33357.

| have written reason at #33357#note-2.

Files

patch_screenshot.png 28 KB 2014-09-06 Tobias Fischer

3.4.png 33.3KB 2020-04-26 Toshi MARUYAMA

4.1.png 30 KB 2020-04-26 Toshi MARUYAMA
https://www.redmine.org/issues/33357
https://www.redmine.org/issues/33357#note-2
http://www.tcpdf.org

